#!/bin/bash

adapter=wlo1
adapter_mon="${wlo1}mon"

# Check for root privileges
if [ "$(id -u)" != "0" ]
then
    >&2 echo "Quitting, this script has to be run as root!"
    exit 1
fi

# Activate Monitor mode
trackerjacker --monitor-mode-on -i $adapter

# Run scan
trackerjacker -i $adapter_mon --map

# Deactivate Monitor mode
trackerjacker --monitor-mode-off -i $adapter_mon


# Wait for WiFi to reconnect
sleep 20

# Filter & upload results
python upload.py

# Remove old scan results
rm wifi_map.yaml